
/*  A Bison parser, made from scanner.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TOK_B_START	257
#define	TOK_B_END	258
#define	TOK_EM_START	259
#define	TOK_EM_END	260
#define	TOK_I_START	261
#define	TOK_I_END	262
#define	TOK_PL_START	263
#define	TOK_PL_END	264
#define	TOK_S_START	265
#define	TOK_S_END	266
#define	TOK_TT_START	267
#define	TOK_TT_END	268
#define	TOK_U_START	269
#define	TOK_U_END	270
#define	TOK_0_START	271
#define	TOK_0_END	272
#define	TOK_1_START	273
#define	TOK_1_END	274
#define	TOK_2_START	275
#define	TOK_2_END	276
#define	TOK_3_START	277
#define	TOK_3_END	278
#define	TOK_4_START	279
#define	TOK_4_END	280
#define	TOK_5_START	281
#define	TOK_5_END	282
#define	TOK_6_START	283
#define	TOK_6_END	284
#define	TOK_7_START	285
#define	TOK_7_END	286
#define	TOK_8_START	287
#define	TOK_8_END	288
#define	TOK_9_START	289
#define	TOK_9_END	290
#define	TOK_r_START	291
#define	TOK_r_END	292
#define	TOK_g_START	293
#define	TOK_g_END	294
#define	TOK_b_START	295
#define	TOK_b_END	296
#define	TOK_c_START	297
#define	TOK_c_END	298
#define	TOK_m_START	299
#define	TOK_m_END	300
#define	TOK_y_START	301
#define	TOK_y_END	302
#define	TOK_k_START	303
#define	TOK_k_END	304
#define	TOK_w_START	305
#define	TOK_w_END	306
#define	TOK_CR	307
#define	TOK_LF	308
#define	TOK_TAB	309
#define	TOK_SPC	310
#define	TOK_CHAR	311

#line 6 "scanner.y"


#include "llist.h"

#define YYSTYPE char

extern UINT32 fpintermediatecount;
extern FILE *fpintermediate;

STATIC INLINE
greg_printf(char *string, int len)
{
	fputs(string, fpintermediate);
	fpintermediatecount += len;
}

STATIC INLINE
greg_printc(char c)
{
	fputc(c, fpintermediate);
	fpintermediatecount++;
}

typedef struct pl_state_holder
{
	UINT32	state;
	UINT32	bcount;
	UINT32	icount;
	UINT32	ucount;
	UINT32	scount;
	UINT32	ttcount;
} pl_state_holder;

typedef struct color_state_holder
{
	UINT32	state;
	UINT32	flags;
	UINT32	count;
} color_state_holder;

typedef struct size_state_holder
{
	UINT32	state;
	UINT32	flags;
	UINT32	count;
} size_state_holder;

PLIST	head_of_list	= NULL;
PLIST	sflag_stack		= NULL;
PLIST	plflag_stack	= NULL;
PLIST	size_stack		= NULL;
PLIST	color_stack		= NULL;

pl_state_holder	*plstate = NULL;
color_state_holder *colorstate = NULL;
size_state_holder *sizestate = NULL;

extern int debug;

STATIC INLINE pl_state_holder *
new_pl_state_holder(void)
{
	pl_state_holder *tmp;

	tmp = (pl_state_holder *)malloc(sizeof(pl_state_holder));
	if (!tmp)
		exit(-1);
	memset(tmp, 0, sizeof(pl_state_holder));
	return tmp;
}

STATIC INLINE void
free_pl_state_holder(pl_state_holder *p)
{
	if (p)
		free(p);
}

STATIC INLINE void
push_pl_state(void)
{
	pl_state_holder *new_state = new_pl_state_holder();
	new_record(plflag_stack, (UINT32)plstate);
	plstate = new_state;
}

STATIC INLINE void
pop_pl_state(void)
{
	PLIST_ENTRY die = get_last_entry(plflag_stack);
	UINT32 pstate = get_this_state(die);

	release_record(plflag_stack, die);
	free_pl_state_holder(plstate);
	plstate = (pl_state_holder *)pstate;
}

STATIC INLINE color_state_holder *
new_color_state_holder(void)
{
	color_state_holder *tmp;

	tmp = (color_state_holder *)malloc(sizeof(color_state_holder));
	if (!tmp)
		exit(-1);
	memset(tmp, 0, sizeof(color_state_holder));
	return tmp;
}

STATIC INLINE void
free_color_state_holder(color_state_holder *p)
{
	if (p)
		free(p);
}

STATIC INLINE void
push_color_state(void)
{
	color_state_holder *new_state = new_color_state_holder();
	new_record(color_stack, (UINT32)colorstate);
	new_state->state = colorstate->state;
	new_state->flags = colorstate->flags;
	colorstate = new_state;
}

STATIC INLINE void
pop_color_state(void)
{
	PLIST_ENTRY die = get_last_entry(color_stack);
	UINT32 pstate = get_this_state(die);

	release_record(color_stack, die);
	free_color_state_holder(colorstate);
	colorstate = (color_state_holder *)pstate;
}


STATIC INLINE size_state_holder *
new_size_state_holder(void)
{
	size_state_holder *tmp;

	tmp = (size_state_holder *)malloc(sizeof(size_state_holder));
	if (!tmp)
		exit(-1);
	memset(tmp, 0, sizeof(size_state_holder));
	return tmp;
}

STATIC INLINE void
free_size_state_holder(size_state_holder *p)
{
	if (p)
		free(p);
}

STATIC INLINE void
push_size_state(void)
{
	size_state_holder *new_state = new_size_state_holder();
	new_record(size_stack, (UINT32)sizestate);
	new_state->state = sizestate->state;
	new_state->flags = sizestate->flags;
	sizestate = new_state;
}

STATIC INLINE void
pop_size_state(void)
{
	PLIST_ENTRY die = get_last_entry(size_stack);
	UINT32 pstate = get_this_state(die);

	release_record(size_stack, die);
	free_size_state_holder(sizestate);
	sizestate = (size_state_holder *)pstate;
}

#define	INSERT_SIZE(x, y)	{										\
		PLIST_ENTRY entry = get_last_entry(head_of_list);			\
		UINT32 pstate = get_this_state(entry);						\
																	\
		if ((pstate & SIZE_FLAG_MASK) != (y))						\
		{															\
			greg_printf((x), 3);									\
			if (entry->current != 0)								\
				new_record(head_of_list, get_this_state(entry));	\
			sizestate->state = pstate;								\
			push_size_state();										\
			add_state(head_of_list, (y));							\
		}															\
		sizestate->count++;											\
}


#define	REMOVE_SIZE(x)	{ 										\
	sizestate->count--;											\
	if (sizestate->count == 0)									\
	{															\
		PLIST_ENTRY entry = get_last_entry(head_of_list);		\
																\
		greg_printf((x), 4);									\
																\
		pop_size_state();										\
																\
		if (entry->current != 0)								\
			new_record(head_of_list, sizestate->state);			\
		else entry->state = sizestate->state;					\
	}															\
}

#define	INSERT_COLOR(x, y)	{										\
		PLIST_ENTRY entry = get_last_entry(head_of_list);			\
		UINT32 pstate = get_this_state(entry);						\
																	\
		if ((pstate & COLOR_FLAG_MASK) != (y))						\
		{															\
			greg_printf((x), 3);									\
			if (entry->current != 0)								\
				new_record(head_of_list, get_this_state(entry));	\
			colorstate->state = pstate;								\
			push_color_state();										\
			add_state(head_of_list, (y));							\
		}															\
		colorstate->count++;										\
}

#define	REMOVE_COLOR(x)		{									\
	colorstate->count--;										\
	if (colorstate->count == 0)									\
	{															\
		PLIST_ENTRY entry = get_last_entry(head_of_list);		\
																\
		greg_printf((x), 4);									\
																\
		pop_color_state();										\
																\
		if (entry->current != 0)								\
			new_record(head_of_list, colorstate->state);		\
		else entry->state = colorstate->state;					\
	}															\
}

#define	INSERT_WS(x)	{											\
	if (add_char(head_of_list, (x)) == 1)							\
	{																\
		if (get_this_state(get_last_entry(head_of_list)) & TT_Flag)	\
			greg_printc((x));										\
		else greg_printc(' ');										\
	}																\
}

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		58
#define	YYFLAG		-32768
#define	YYNTBASE	58

#define YYTRANSLATE(x) ((unsigned)(x) <= 311 ? yytranslate[x] : 59)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,    10,    13,    16,    19,    22,    25,
    28,    31,    34,    37,    40,    43,    46,    49,    52,    55,
    58,    61,    64,    67,    70,    73,    76,    79,    82,    85,
    88,    91,    94,    97,   100,   103,   106,   109,   112,   115,
   118,   121,   124,   127,   130,   133,   136,   139,   142,   145,
   148,   151,   154,   157,   160,   163
};

static const short yyrhs[] = {    -1,
    58,    57,     0,    58,    55,     0,    58,    54,     0,    58,
    53,     0,    58,    56,     0,    58,     3,     0,    58,     5,
     0,    58,     7,     0,    58,     9,     0,    58,    11,     0,
    58,    13,     0,    58,    15,     0,    58,    17,     0,    58,
    19,     0,    58,    21,     0,    58,    23,     0,    58,    25,
     0,    58,    27,     0,    58,    29,     0,    58,    31,     0,
    58,    33,     0,    58,    35,     0,    58,    37,     0,    58,
    39,     0,    58,    41,     0,    58,    43,     0,    58,    45,
     0,    58,    47,     0,    58,    49,     0,    58,    51,     0,
    58,     4,     0,    58,     6,     0,    58,     8,     0,    58,
    10,     0,    58,    12,     0,    58,    14,     0,    58,    16,
     0,    58,    18,     0,    58,    20,     0,    58,    22,     0,
    58,    24,     0,    58,    26,     0,    58,    28,     0,    58,
    30,     0,    58,    32,     0,    58,    34,     0,    58,    36,
     0,    58,    38,     0,    58,    40,     0,    58,    42,     0,
    58,    44,     0,    58,    46,     0,    58,    48,     0,    58,
    50,     0,    58,    52,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   322,   323,   327,   328,   329,   330,   332,   345,   369,   382,
   406,   424,   437,   455,   456,   457,   458,   459,   460,   461,
   462,   463,   464,   466,   467,   468,   469,   470,   471,   472,
   473,   475,   488,   506,   519,   535,   556,   569,   588,   589,
   590,   591,   592,   593,   594,   595,   596,   597,   599,   600,
   601,   602,   603,   604,   605,   606
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TOK_B_START",
"TOK_B_END","TOK_EM_START","TOK_EM_END","TOK_I_START","TOK_I_END","TOK_PL_START",
"TOK_PL_END","TOK_S_START","TOK_S_END","TOK_TT_START","TOK_TT_END","TOK_U_START",
"TOK_U_END","TOK_0_START","TOK_0_END","TOK_1_START","TOK_1_END","TOK_2_START",
"TOK_2_END","TOK_3_START","TOK_3_END","TOK_4_START","TOK_4_END","TOK_5_START",
"TOK_5_END","TOK_6_START","TOK_6_END","TOK_7_START","TOK_7_END","TOK_8_START",
"TOK_8_END","TOK_9_START","TOK_9_END","TOK_r_START","TOK_r_END","TOK_g_START",
"TOK_g_END","TOK_b_START","TOK_b_END","TOK_c_START","TOK_c_END","TOK_m_START",
"TOK_m_END","TOK_y_START","TOK_y_END","TOK_k_START","TOK_k_END","TOK_w_START",
"TOK_w_END","TOK_CR","TOK_LF","TOK_TAB","TOK_SPC","TOK_CHAR","document", NULL
};
#endif

static const short yyr1[] = {     0,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58
};

static const short yyr2[] = {     0,
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2
};

static const short yydefact[] = {     1,
     0,     7,    32,     8,    33,     9,    34,    10,    35,    11,
    36,    12,    37,    13,    38,    14,    39,    15,    40,    16,
    41,    17,    42,    18,    43,    19,    44,    20,    45,    21,
    46,    22,    47,    23,    48,    24,    49,    25,    50,    26,
    51,    27,    52,    28,    53,    29,    54,    30,    55,    31,
    56,     5,     4,     3,     6,     2,     0,     0
};

static const short yydefgoto[] = {     1
};

static const short yypact[] = {-32768,
     0,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,     1,-32768
};

static const short yypgoto[] = {-32768
};


#define	YYLAST		57


static const short yytable[] = {    57,
    58,     0,     2,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56
};

static const short yycheck[] = {     0,
     0,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 323 "scanner.y"
{ 
		greg_printc(yyvsp[0]);
		add_char(head_of_list, yyvsp[0]);
	;
    break;}
case 3:
#line 327 "scanner.y"
{ INSERT_WS('	'); ;
    break;}
case 4:
#line 328 "scanner.y"
{ INSERT_WS('\n'); ;
    break;}
case 5:
#line 329 "scanner.y"
{ INSERT_WS('\r'); ;
    break;}
case 6:
#line 330 "scanner.y"
{ INSERT_WS(' '); ;
    break;}
case 7:
#line 332 "scanner.y"
{
		PLIST_ENTRY entry = get_last_entry(head_of_list);

		if (plstate->bcount == 0)
		{
			greg_printf("<B>", 3);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			add_state(head_of_list, B_Flag);
		}
		plstate->bcount++;
	;
    break;}
case 8:
#line 345 "scanner.y"
{
		PLIST_ENTRY entry = get_last_entry(head_of_list);
		UINT32 pstate = get_this_state(entry);

		if (!(pstate & S_Flag))
		{
			greg_printf("<EM>", 4);
			if (entry->current != 0)
				new_record(head_of_list, pstate);
			if (pstate & EM_Flag) {
				remove_state(get_last_entry(head_of_list), EM_Flag);
				if (get_this_state(get_last_entry(head_of_list)) & ForceEMSet) {
					add_flag(head_of_list, ForceEMOff);
					remove_flag(head_of_list, ForceEMSet);
					remove_flag(head_of_list, PLAdded);
				}
			}
			else {
				add_state(head_of_list, EM_Flag);
				remove_flag(head_of_list, ForceEMSet);
				remove_flag(head_of_list, PLAdded);
			}
		}
	;
    break;}
case 9:
#line 369 "scanner.y"
{ 
		PLIST_ENTRY entry = get_last_entry(head_of_list);

		if (plstate->icount == 0)
		{
			greg_printf("<I>", 3);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			add_state(head_of_list, I_Flag);
		}
		plstate->icount++;
	;
    break;}
case 10:
#line 382 "scanner.y"
{
		PLIST_ENTRY entry = get_last_entry(head_of_list);
		UINT32 pstate = get_this_state(entry);
		PLIST_ENTRY last;

		greg_printf("<PL>", 4);
		if (entry->current != 0)
			new_record(head_of_list, pstate);

		plstate->state = pstate;
		push_pl_state();

		last = get_last_entry(head_of_list);
		remove_state(last, S_Flag);
		remove_state(last, EM_Flag);
		remove_state(last, I_Flag);
		remove_state(last, B_Flag);
		remove_state(last, TT_Flag);
		remove_state(last, U1_Flag);
		remove_state(last, U2_Flag);
		remove_state(last, U3_Flag);
		add_flag(head_of_list, PLAdded);
		add_flag(head_of_list, ForceEMSet);
	;
    break;}
case 11:
#line 406 "scanner.y"
{ 
		PLIST_ENTRY entry = get_last_entry(head_of_list);
		UINT32 pstate = get_this_state(entry);

		if (plstate->scount == 0)
		{
			greg_printf("<S>", 3);

			if (entry->current != 0)
				new_record(head_of_list, pstate);
			new_record(sflag_stack, pstate);
			add_state(head_of_list, S_Flag);
			add_flag(head_of_list, ForceEMOff);
			remove_flag(head_of_list, ForceEMSet);
			remove_state(get_last_entry(head_of_list), EM_Flag);
		}
		plstate->scount++;
	;
    break;}
case 12:
#line 424 "scanner.y"
{ 
		PLIST_ENTRY entry = get_last_entry(head_of_list);

		if (plstate->ttcount == 0)
		{
			greg_printf("<TT>", 4);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			add_state(head_of_list, TT_Flag);
		}
		plstate->ttcount++;
	;
    break;}
case 13:
#line 437 "scanner.y"
{
		plstate->ucount++;
		if (plstate->ucount <= 3)
		{
			PLIST_ENTRY entry = get_last_entry(head_of_list);

			greg_printf("<U>", 3);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			add_state(head_of_list, U1_Flag);
			if (plstate->ucount >= 2)
				add_state(head_of_list, U2_Flag);
			if (plstate->ucount >= 3)
				add_state(head_of_list, U3_Flag);
		}
	;
    break;}
case 14:
#line 455 "scanner.y"
{ INSERT_SIZE("<0>", S0_Flag); ;
    break;}
case 15:
#line 456 "scanner.y"
{ INSERT_SIZE("<1>", S1_Flag); ;
    break;}
case 16:
#line 457 "scanner.y"
{ INSERT_SIZE("<2>", S2_Flag); ;
    break;}
case 17:
#line 458 "scanner.y"
{ INSERT_SIZE("<3>", S3_Flag); ;
    break;}
case 18:
#line 459 "scanner.y"
{ INSERT_SIZE("<4>", S4_Flag); ;
    break;}
case 19:
#line 460 "scanner.y"
{ INSERT_SIZE("<5>", S5_Flag); ;
    break;}
case 20:
#line 461 "scanner.y"
{ INSERT_SIZE("<6>", S6_Flag); ;
    break;}
case 21:
#line 462 "scanner.y"
{ INSERT_SIZE("<7>", S7_Flag); ;
    break;}
case 22:
#line 463 "scanner.y"
{ INSERT_SIZE("<8>", S8_Flag); ;
    break;}
case 23:
#line 464 "scanner.y"
{ INSERT_SIZE("<9>", S9_Flag); ;
    break;}
case 24:
#line 466 "scanner.y"
{ INSERT_COLOR("<r>", Cr_Flag); ;
    break;}
case 25:
#line 467 "scanner.y"
{ INSERT_COLOR("<g>", Cg_Flag); ;
    break;}
case 26:
#line 468 "scanner.y"
{ INSERT_COLOR("<b>", Cb_Flag); ;
    break;}
case 27:
#line 469 "scanner.y"
{ INSERT_COLOR("<c>", Cc_Flag); ;
    break;}
case 28:
#line 470 "scanner.y"
{ INSERT_COLOR("<m>", Cm_Flag); ;
    break;}
case 29:
#line 471 "scanner.y"
{ INSERT_COLOR("<y>", Cy_Flag); ;
    break;}
case 30:
#line 472 "scanner.y"
{ INSERT_COLOR("<k>", Ck_Flag); ;
    break;}
case 31:
#line 473 "scanner.y"
{ INSERT_COLOR("<w>", Cw_Flag); ;
    break;}
case 32:
#line 475 "scanner.y"
{ 
		plstate->bcount--;
		if (plstate->bcount == 0)
		{
			PLIST_ENTRY entry = get_last_entry(head_of_list);

			greg_printf("</B>", 4);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			remove_state(get_last_entry(head_of_list), B_Flag);
		}
	;
    break;}
case 33:
#line 488 "scanner.y"
{ 
		PLIST_ENTRY entry = get_last_entry(head_of_list);
		UINT32 pstate = get_this_state(entry);

		if (!(pstate & S_Flag))
		{
			greg_printf("</EM>", 5);
			if (entry->current != 0)
				new_record(head_of_list, pstate);
			if (pstate & EM_Flag) {
				remove_state(get_last_entry(head_of_list), EM_Flag);
				if (get_this_state(get_last_entry(head_of_list)) & ForceEMSet) {
					add_flag(head_of_list, ForceEMOff);
					remove_flag(head_of_list, ForceEMSet);
				}
			} else add_state(head_of_list, EM_Flag);
		}
	;
    break;}
case 34:
#line 506 "scanner.y"
{ 
		plstate->icount--;
		if (plstate->icount == 0)
		{
			PLIST_ENTRY entry = get_last_entry(head_of_list);

			greg_printf("</I>", 4);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			remove_state(get_last_entry(head_of_list), I_Flag);
		}
	;
    break;}
case 35:
#line 519 "scanner.y"
{
		PLIST_ENTRY entry = get_last_entry(head_of_list);

		greg_printf("</PL>", 5);

		pop_pl_state();

		if (entry->current != 0)
			new_record(head_of_list, plstate->state);
		else entry->state = plstate->state;
		if (plstate->state & EM_Flag) {
//			add_flag(head_of_list, ForceEMSet);
//			add_flag(head_of_list, PLRemoved);
//			remove_flag(head_of_list, ForceEMOff);
		}
	;
    break;}
case 36:
#line 535 "scanner.y"
{ 
		plstate->scount--;
		if (plstate->scount == 0)
		{
			PLIST_ENTRY die = get_last_entry(sflag_stack);
			UINT32 pstate = get_this_state(die);
			PLIST_ENTRY entry = get_last_entry(head_of_list);

			greg_printf("</S>", 4);

			release_record(sflag_stack, die);

			if (entry->current != 0)
				new_record(head_of_list, pstate);
			else entry->state = pstate;
			if (pstate & EM_Flag) {
				add_flag(head_of_list, ForceEMSet);
				remove_flag(head_of_list, ForceEMOff);
			}
		}
	;
    break;}
case 37:
#line 556 "scanner.y"
{ 
		plstate->ttcount--;
		if (plstate->ttcount == 0)
		{
			PLIST_ENTRY entry = get_last_entry(head_of_list);

			greg_printf("</TT>", 5);

			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));
			remove_state(get_last_entry(head_of_list), TT_Flag);
		}
	;
    break;}
case 38:
#line 569 "scanner.y"
{
		if (plstate->ucount <= 3)
		{
			PLIST_ENTRY entry = get_last_entry(head_of_list);

			greg_printf("</U>", 4);
			
			if (entry->current != 0)
				new_record(head_of_list, get_this_state(entry));

			remove_state(get_last_entry(head_of_list), U3_Flag);
			if (plstate->ucount <= 2)
				remove_state(get_last_entry(head_of_list), U2_Flag);
			if (plstate->ucount <= 1)
				remove_state(get_last_entry(head_of_list), U1_Flag);
		}
		plstate->ucount--;
	;
    break;}
case 39:
#line 588 "scanner.y"
{ REMOVE_SIZE("</0>"); ;
    break;}
case 40:
#line 589 "scanner.y"
{ REMOVE_SIZE("</1>"); ;
    break;}
case 41:
#line 590 "scanner.y"
{ REMOVE_SIZE("</2>"); ;
    break;}
case 42:
#line 591 "scanner.y"
{ REMOVE_SIZE("</3>"); ;
    break;}
case 43:
#line 592 "scanner.y"
{ REMOVE_SIZE("</4>"); ;
    break;}
case 44:
#line 593 "scanner.y"
{ REMOVE_SIZE("</5>"); ;
    break;}
case 45:
#line 594 "scanner.y"
{ REMOVE_SIZE("</6>"); ;
    break;}
case 46:
#line 595 "scanner.y"
{ REMOVE_SIZE("</7>"); ;
    break;}
case 47:
#line 596 "scanner.y"
{ REMOVE_SIZE("</8>"); ;
    break;}
case 48:
#line 597 "scanner.y"
{ REMOVE_SIZE("</9>"); ;
    break;}
case 49:
#line 599 "scanner.y"
{ REMOVE_COLOR("</r>"); ;
    break;}
case 50:
#line 600 "scanner.y"
{ REMOVE_COLOR("</g>"); ;
    break;}
case 51:
#line 601 "scanner.y"
{ REMOVE_COLOR("</b>"); ;
    break;}
case 52:
#line 602 "scanner.y"
{ REMOVE_COLOR("</c>"); ;
    break;}
case 53:
#line 603 "scanner.y"
{ REMOVE_COLOR("</m>"); ;
    break;}
case 54:
#line 604 "scanner.y"
{ REMOVE_COLOR("</y>"); ;
    break;}
case 55:
#line 605 "scanner.y"
{ REMOVE_COLOR("</k>"); ;
    break;}
case 56:
#line 606 "scanner.y"
{ REMOVE_COLOR("</w>"); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 609 "scanner.y"


int
yyerror(char *s)
{
	fprintf(stderr, "%s\n", s);
}


void
yyparse_init()
{
	new_list(&sflag_stack);
	new_list(&plflag_stack);
	new_list(&size_stack);
	new_list(&color_stack);
	new_list(&head_of_list);
	new_record(head_of_list, 0);
	plstate = new_pl_state_holder();
	colorstate = new_color_state_holder();
	sizestate = new_size_state_holder();
}

void
yyparse_complete()
{
	release_list(sflag_stack);
	release_list(plflag_stack);
	release_list(size_stack);
	release_list(color_stack);

	free_size_state_holder(sizestate);
	free_color_state_holder(colorstate);
	free_pl_state_holder(plstate);
}

